package com.fr.plugin.function.config;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.intelli.record.Focus;
import com.fr.intelli.record.Original;
import com.fr.record.analyzer.EnableMetrics;
import com.fr.stable.fun.Authorize;

@Visualization(category = "单点登录配置")
@EnableMetrics
@Authorize(callSignKey = "com.fr.plugin.xxxx.bkfunction")
public class PluginSimpleConfig extends DefaultConfiguration {

    private static volatile PluginSimpleConfig config = null;

    @Focus(id="com.fr.plugin.xxxx.config", text = "单点登录配置", source = Original.PLUGIN)
    public static PluginSimpleConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(PluginSimpleConfig.class);
        }
        return config;
    }

    @Identifier(value = "url", name = "接口地址", description = "接口地址", status = Status.SHOW)
    private Conf<String> url = Holders.simple("http://xxxx/auth/soa/dataauth/findAllDataRuleAuth");

    @Identifier(value = "projectValue", name = "projectValue", description = "参数", status = Status.SHOW)
    private Conf<String> projectValue = Holders.simple("xxxx");

    @Identifier(value = "systemSource", name = "systemSource", description = "参数", status = Status.SHOW)
    private Conf<String> systemSource = Holders.simple("xxxx");

    @Identifier(value = "resourceTypeValue", name = "resourceTypeValue", description = "参数", status = Status.SHOW)
    private Conf<String> resourceTypeValue = Holders.simple("xxxx");

    @Identifier(value = "option", name = "option", description = "参数", status = Status.SHOW)
    private Conf<String> option = Holders.simple("-1");

    @Identifier(value = "corp", name = "集团字段", description = "集团字段", status = Status.SHOW)
    private Conf<String> corp = Holders.simple("xxxx");

    @Identifier(value = "area", name = "区域", description = "区域", status = Status.SHOW)
    private Conf<String> area = Holders.simple("xxxx");

    @Identifier(value = "city", name = "城市", description = "城市", status = Status.SHOW)
    private Conf<String> city = Holders.simple("xxxx");

    @Identifier(value = "project", name = "项目", description = "项目", status = Status.SHOW)
    private Conf<String> project = Holders.simple("xxxx");

    public String getUrl() {
        return url.get();
    }

    public void setUrl(String url) {
        this.url.set(url);
    }

    public String getProjectValue() {
        return projectValue.get();
    }

    public void setProjectValue(String url) {
        this.projectValue.set(url);
    }

    public String getSystemSource() {
        return systemSource.get();
    }

    public void setSystemSource(String url) {
        this.systemSource.set(url);
    }

    public String getResourceTypeValue() {
        return resourceTypeValue.get();
    }

    public void setResourceTypeValue(String url) {
        this.resourceTypeValue.set(url);
    }

    public String getOption() {
        return option.get();
    }

    public void setOption(String url) {
        this.option.set(url);
    }

    public String getCorp() {
        return corp.get();
    }

    public void setCorp(String url) {
        this.corp.set(url);
    }

    public String getArea() {
        return area.get();
    }

    public void setArea(String url) {
        this.area.set(url);
    }

    public String getCity() {
        return city.get();
    }

    public void setCity(String url) {
        this.city.set(url);
    }

    public String getProject() {
        return project.get();
    }

    public void setProject(String url) {
        this.project.set(url);
    }
    @Override
    public Object clone() throws CloneNotSupportedException {
        PluginSimpleConfig cloned = (PluginSimpleConfig) super.clone();
//        cloned.text = (Conf<String>) text.clone();
//        cloned.count = (Conf<Integer>) count.clone();
//        cloned.price = (Conf<Double>) price.clone();
//        cloned.time = (Conf<Long>) time.clone();
//        cloned.student = (Conf<Boolean>) student.clone();
        return cloned;
    }

}
